/*
 * jsUri v1.1.1
 * https://github.com/derek-watson/jsUri
 *
 * Copyright 2011, Derek Watson
 * Released under the MIT license.
 * http://jquery.org/license
 *
 * Includes parseUri regular expressions
 * http://blog.stevenlevithan.com/archives/parseuri
 * Copyright 2007, Steven Levithan
 * Released under the MIT license.
 *
 * Date: Mon Nov 14 20:06:34 2011 -0800
 */
var Query=function(B){var E=function(N){var K=[],M,P,O,L;if(typeof (N)==="undefined"||N===null||N===""){return K}if(N.indexOf("?")===0){N=N.substring(1)}P=N.toString().split(/[&;]/);for(M=0;M<P.length;M++){O=P[M];L=O.split("=");K.push([L[0],L[1]])}return K},D=E(B),C=function(){var L="",K,M;for(K=0;K<D.length;K++){M=D[K];if(L.length>0){L+="&"}L+=M.join("=")}return L.length>0?"?"+L:L},A=function(K){K=decodeURIComponent(K);K=K.replace("+"," ");return K},I=function(L){var M,K;for(K=0;K<D.length;K++){M=D[K];if(A(L)===A(M[0])){return M[1]}}},H=function(M){var K=[],L,N;for(L=0;L<D.length;L++){N=D[L];if(A(M)===A(N[0])){K.push(N[1])}}return K},J=function(N,Q){var K=[],M,P,L,O;for(M=0;M<D.length;M++){P=D[M];L=A(P[0])===A(N);O=A(P[1])===A(Q);if((arguments.length===1&&!L)||(arguments.length===2&&!L&&!O)){K.push(P)}}D=K;return this},F=function(L,M,K){if(arguments.length===3&&K!==-1){K=Math.min(K,D.length);D.splice(K,0,[L,M])}else{if(arguments.length>0){D.push([L,M])}}return this},G=function(O,M,K){var L=-1,N,P;if(arguments.length===3){for(N=0;N<D.length;N++){P=D[N];if(A(P[0])===A(O)&&decodeURIComponent(P[1])===A(K)){L=N;break}}J(O,K).addParam(O,M,L)}else{for(N=0;N<D.length;N++){P=D[N];if(A(P[0])===A(O)){L=N;break}}J(O);F(O,M,L)}return this};return{getParamValue:I,getParamValues:H,deleteParam:J,addParam:F,replaceParam:G,toString:C}};var Uri=function(K){var L=false,X=function(k){var f={strict:/^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,loose:/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/},h=["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],j={name:"queryKey",parser:/(?:^|&)([^&=]*)=?([^&]*)/g},d=f[L?"strict":"loose"].exec(k),g={},e=14;while(e--){g[h[e]]=d[e]||""}g[j.name]={};g[h[12]].replace(j.parser,function(l,i,m){if(i){g[j.name][i]=m}});return g},J=X(K||""),c=new Query(J.query),O=function(d){if(typeof d!=="undefined"){J.protocol=d}return J.protocol},H=null,B=function(d){if(typeof d!=="undefined"){H=d}if(H===null){return(J.source.indexOf("//")!==-1)}else{return H}},G=function(d){if(typeof d!=="undefined"){J.userInfo=d}return J.userInfo},P=function(d){if(typeof d!=="undefined"){J.host=d}return J.host},M=function(d){if(typeof d!=="undefined"){J.port=d}return J.port},R=function(d){if(typeof d!=="undefined"){J.path=d}return J.path},F=function(d){if(typeof d!=="undefined"){c=new Query(d)}return c},I=function(d){if(typeof d!=="undefined"){J.anchor=d}return J.anchor},W=function(d){O(d);return this},S=function(d){B(d);return this},N=function(d){G(d);return this},Y=function(d){P(d);return this},U=function(d){M(d);return this},b=function(d){R(d);return this},T=function(d){F(d);return this},A=function(d){I(d);return this},C=function(d){return F().getParamValue(d)},E=function(d){return F().getParamValues(d)},Z=function(d,e){if(arguments.length===2){F().deleteParam(d,e)}else{F().deleteParam(d)}return this},D=function(e,f,d){if(arguments.length===3){F().addParam(e,f,d)}else{F().addParam(e,f)}return this},Q=function(f,e,d){if(arguments.length===3){F().replaceParam(f,e,d)}else{F().replaceParam(f,e)}return this},V=function(){var d="",e=function(f){return(f!==null&&f!=="")};if(e(O())){d+=O();if(O().indexOf(":")!==O().length-1){d+=":"}d+="//"}else{if(B()&&e(P())){d+="//"}}if(e(G())&&e(P())){d+=G();if(G().indexOf("@")!==G().length-1){d+="@"}}if(e(P())){d+=P();if(e(M())){d+=":"+M()}}if(e(R())){d+=R()}else{if(e(P())&&(e(F().toString())||e(I()))){d+="/"}}if(e(F().toString())){if(F().toString().indexOf("?")!==0){d+="?"}d+=F().toString()}if(e(I())){if(I().indexOf("#")!==0){d+="#"}d+=I()}return d},a=function(){return new Uri(V())};return{protocol:O,hasAuthorityPrefix:B,userInfo:G,host:P,port:M,path:R,query:F,anchor:I,setProtocol:W,setHasAuthorityPrefix:S,setUserInfo:N,setHost:Y,setPort:U,setPath:b,setQuery:T,setAnchor:A,getQueryParamValue:C,getQueryParamValues:E,deleteQueryParam:Z,addQueryParam:D,replaceQueryParam:Q,toString:V,clone:a}};var jsUri=Uri;